// PaintDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Graphics.h"
#include "PaintDlg.h"
#include "GraphicsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const COLORREF CPaintDlg::m_crColors[8] = {
	RGB(   0,   0,   0),	// Black
	RGB(   0,   0, 255),	// Blue
	RGB(   0, 255,   0),	// Green
	RGB(   0, 255, 255),	// Cyan
	RGB( 255,   0,   0),	// Red
	RGB( 255,   0, 255),	// Magenta
	RGB( 255, 255,   0),	// Yellow
	RGB( 255, 255, 255)		// White
};
/////////////////////////////////////////////////////////////////////////////
// CPaintDlg dialog


CPaintDlg::CPaintDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPaintDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPaintDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CPaintDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPaintDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPaintDlg, CDialog)
	//{{AFX_MSG_MAP(CPaintDlg)
	ON_WM_PAINT()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPaintDlg message handlers

void CPaintDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

	// Get a pointer to the parent window
	CGraphicsDlg *pWnd = (CGraphicsDlg*)GetParent();
	// Do we have a valid pointer?
	if (pWnd)
	{
		m_iTool = pWnd->m_iTool;
		m_iColor = pWnd->m_iColor;
		m_iShape = pWnd->m_iShape;
		m_strBitmap = pWnd->m_strBitmap;
		// Is the tool a bitmap?
		if (m_iTool == 2)
		{
			// Is there a bitmap selected and loaded?
			if (m_strBitmap != "")
				// Display it
				ShowBitmap(&dc, pWnd);
		}
		else	// No, were drawing a shape
		{
			// Are we drawing a line?
			if (m_iShape == 0)
				DrawLine(&dc);
			else	// Were drawing a ellipse or rectangle
				DrawRegion(&dc);
		}
	}
	// Do not call CDialog::OnPaint() for painting messages
}

void CPaintDlg::DrawLine(CPaintDC *pdc)
{
	// Declare and create the pens
	CPen lSolidPen (PS_SOLID, 1, m_crColors[m_iColor]);
	CPen lDotPen (PS_DOT, 1, m_crColors[m_iColor]);
	CPen lDashPen (PS_DASH, 1, m_crColors[m_iColor]);
	CPen lDashDotPen (PS_DASHDOT, 1, m_crColors[m_iColor]);
	CPen lDashDotDotPen (PS_DASHDOTDOT, 1, m_crColors[m_iColor]);
	CPen lNullPen (PS_NULL, 1, m_crColors[m_iColor]);
	CPen lInsidePen (PS_INSIDEFRAME, 1, m_crColors[m_iColor]);
	
	// Get the drawing area
	CRect lRect;
	GetClientRect(lRect);
	lRect.NormalizeRect();

	// Calculate the distance between each of the lines
	CPoint pStart;
	CPoint pEnd;
	int liDist = lRect.Height() / 8;
	CPen *pOldPen;
	// Specify the starting points
	pStart.y = lRect.top;
	pStart.x = lRect.left;
	pEnd.y = pStart.y;
	pEnd.x = lRect.right;
	int i;
	// Loop through the different pens
	for (i = 0; i < 7; i++)
	{
		// Which pen are we on?
		switch (i)
		{
		case 0:	// Solid
			pOldPen = pdc->SelectObject(&lSolidPen);
			break;
		case 1:	// Dot
			pdc->SelectObject(&lDotPen);
			break;
		case 2:	// Dash
			pdc->SelectObject(&lDashPen);
			break;
		case 3:	// Dash Dot
			pdc->SelectObject(&lDashDotPen);
			break;
		case 4:	// Dash Dot Dot
			pdc->SelectObject(&lDashDotDotPen);
			break;
		case 5:	// Null
			pdc->SelectObject(&lNullPen);
			break;
		case 6:	// Inside
			pdc->SelectObject(&lInsidePen);
			break;
		}
		// Move down to the next position
		pStart.y = pStart.y + liDist;
		pEnd.y = pStart.y;
		// Draw the line
		pdc->MoveTo(pStart);
		pdc->LineTo(pEnd);
	}
	// Select the original pen
	pdc->SelectObject(pOldPen);
}

void CPaintDlg::ShowBitmap(CPaintDC *pdc, CWnd *pWnd)
{
	// Convert the pointer to a pointer to the main dialog class
	CGraphicsDlg *lpWnd = (CGraphicsDlg*)pWnd;
	BITMAP bm;
	CDC dcMem;
	CRect lRect;

	// Get the loaded bitmap
	lpWnd->m_bBitmap.GetBitmap(&bm);
	// Create a device context to load the bitmap into
	dcMem.CreateCompatibleDC(pdc);
	// Select the bitmap into the compatible device context
	CBitmap* pOldBitmap = (CBitmap*)dcMem.SelectObject(lpWnd->m_bBitmap);
	// Get the display area available
	GetClientRect(lRect);
	lRect.NormalizeRect();
	// Copy and resize the bitmap to the dialog window
	pdc->StretchBlt(10, 10, (lRect.Width() - 20), (lRect.Height() - 20), &dcMem, 0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);
}

void CPaintDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	// Redraw the window
	Invalidate();
}

void CPaintDlg::DrawRegion(CPaintDC *pdc)
{
	// Declare and create the pens
	CPen lSolidPen (PS_SOLID, 1, m_crColors[m_iColor]);
	CPen lDotPen (PS_DOT, 1, m_crColors[m_iColor]);
	CPen lDashPen (PS_DASH, 1, m_crColors[m_iColor]);
	CPen lDashDotPen (PS_DASHDOT, 1, m_crColors[m_iColor]);
	CPen lDashDotDotPen (PS_DASHDOTDOT, 1, m_crColors[m_iColor]);
	CPen lNullPen (PS_NULL, 1, m_crColors[m_iColor]);
	CPen lInsidePen (PS_INSIDEFRAME, 1, m_crColors[m_iColor]);

	// Declare and create the brushes
	CBrush lSolidBrush(m_crColors[m_iColor]);
	CBrush lBDiagBrush(HS_BDIAGONAL, m_crColors[m_iColor]);
	CBrush lCrossBrush(HS_CROSS, m_crColors[m_iColor]);
	CBrush lDiagCrossBrush(HS_DIAGCROSS, m_crColors[m_iColor]);
	CBrush lFDiagBrush(HS_FDIAGONAL, m_crColors[m_iColor]);
	CBrush lHorizBrush(HS_HORIZONTAL, m_crColors[m_iColor]);
	CBrush lVertBrush(HS_VERTICAL, m_crColors[m_iColor]);
	CBrush lNullBrush(RGB(192, 192, 192));

	CBitmap lBitmap;
	lBitmap.LoadBitmap(IDB_BITMAPBRUSH);
	CBrush lBitmapBrush(&lBitmap);

	// Calculate the size the the drawing regions
	CRect lRect;
	GetClientRect(lRect);
	lRect.NormalizeRect();
	int iVert = lRect.Height() / 2;
	int iHeight = iVert - 10;
	int iHorz = lRect.Width() / 4;
	int iWidth = iHorz - 10;
	CRect lDrawRect;
	CPen *pOldPen;
	CBrush *pOldBrush;
	int i;
	// Loop through all of the brushes and pens
	for (i = 0; i < 7; i++)
	{
		switch (i)
		{
		case 0:	// Solid
			// Determine the location for this figure.
			// Start the first row
			lDrawRect.top = lRect.top + 5;
			lDrawRect.left = lRect.left + 5;
			lDrawRect.bottom = lDrawRect.top + iHeight;
			lDrawRect.right = lDrawRect.left + iWidth;
			// Select the appropriate pen and brush
			pOldPen = pdc->SelectObject(&lSolidPen);
			pOldBrush = pdc->SelectObject(&lSolidBrush);
			break;
		case 1:	// Dot - Back Diagonal
			// Determine the location for this figure.
			lDrawRect.left = lDrawRect.left + iHorz;
			lDrawRect.right = lDrawRect.left + iWidth;
			// Select the appropriate pen and brush
			pdc->SelectObject(&lDotPen);
			pdc->SelectObject(&lBDiagBrush);
			break;
		case 2:	// Dash - Cross Brush
			// Determine the location for this figure.
			lDrawRect.left = lDrawRect.left + iHorz;
			lDrawRect.right = lDrawRect.left + iWidth;
			// Select the appropriate pen and brush
			pdc->SelectObject(&lDashPen);
			pdc->SelectObject(&lCrossBrush);
			break;
		case 3:	// Dash Dot - Diagonal Cross
			// Determine the location for this figure.
			lDrawRect.left = lDrawRect.left + iHorz;
			lDrawRect.right = lDrawRect.left + iWidth;
			// Select the appropriate pen and brush
			pdc->SelectObject(&lDashDotPen);
			pdc->SelectObject(&lDiagCrossBrush);
			break;
		case 4:	// Dash Dot Dot - Forward Diagonal
			// Determine the location for this figure.
			// Start the second row
			lDrawRect.top = lDrawRect.top + iVert;
			lDrawRect.left = lRect.left + 5;
			lDrawRect.bottom = lDrawRect.top + iHeight;
			lDrawRect.right = lDrawRect.left + iWidth;
			// Select the appropriate pen and brush
			pdc->SelectObject(&lDashDotDotPen);
			pdc->SelectObject(&lFDiagBrush);
			break;
		case 5:	// Null - Horizontal
			// Determine the location for this figure.
			lDrawRect.left = lDrawRect.left + iHorz;
			lDrawRect.right = lDrawRect.left + iWidth;
			// Select the appropriate pen and brush
			pdc->SelectObject(&lNullPen);
			pdc->SelectObject(&lHorizBrush);
			break;
		case 6:	// Inside - Vertical
			// Determine the location for this figure.
			lDrawRect.left = lDrawRect.left + iHorz;
			lDrawRect.right = lDrawRect.left + iWidth;
			// Select the appropriate pen and brush
			pdc->SelectObject(&lInsidePen);
			pdc->SelectObject(&lVertBrush);
			break;
		case 7:	// Bitmap
			// Determine the location for this figure.
			lDrawRect.left = lDrawRect.left + iHorz;
			lDrawRect.right = lDrawRect.left + iWidth;
			// Select the appropriate pen and brush
			pdc->SelectObject(&lNullPen);
			pdc->SelectObject(&lBitmapBrush);
			break;
		}
		// Which tool are we using?
		if (m_iTool == 0)
			pdc->SelectObject(lNullBrush);
		else
			pdc->SelectObject(lNullPen);
		// Which shape are we drawing?
		if (m_iShape == 1)
			pdc->Ellipse(lDrawRect);
		else
			pdc->Rectangle(lDrawRect);
	}
	// Reset the original brush and pen
	pdc->SelectObject(pOldBrush);
	pdc->SelectObject(pOldPen);
}
