// GraphicsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Graphics.h"
#include "PaintDlg.h"
#include "GraphicsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphicsDlg dialog

CGraphicsDlg::CGraphicsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGraphicsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGraphicsDlg)
	m_iColor = -1;
	m_iShape = -1;
	m_iTool = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGraphicsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGraphicsDlg)
	DDX_Radio(pDX, IDC_RCBLACK, m_iColor);
	DDX_Radio(pDX, IDC_RSLINE, m_iShape);
	DDX_Radio(pDX, IDC_RTPEN, m_iTool);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGraphicsDlg, CDialog)
	//{{AFX_MSG_MAP(CGraphicsDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BEXIT, OnBexit)
	ON_BN_CLICKED(IDC_BBITMAP, OnBbitmap)
	ON_BN_CLICKED(IDC_RCBLACK, OnRcColor)
	ON_BN_CLICKED(IDC_RCBLUE, OnRcColor)
	ON_BN_CLICKED(IDC_RCCYAN, OnRcColor)
	ON_BN_CLICKED(IDC_RCGREEN, OnRcColor)
	ON_BN_CLICKED(IDC_RCMAGENTA, OnRcColor)
	ON_BN_CLICKED(IDC_RCRED, OnRcColor)
	ON_BN_CLICKED(IDC_RCWHITE, OnRcColor)
	ON_BN_CLICKED(IDC_RCYELLOW, OnRcColor)
	ON_BN_CLICKED(IDC_RSCIRCLE, OnRsShape)
	ON_BN_CLICKED(IDC_RSLINE, OnRsShape)
	ON_BN_CLICKED(IDC_RSSQUARE, OnRsShape)
	ON_BN_CLICKED(IDC_RTPEN, OnRtTool)
	ON_BN_CLICKED(IDC_RTBRUSH, OnRtTool)
	ON_BN_CLICKED(IDC_RTBITMAP, OnRtTool)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphicsDlg message handlers

BOOL CGraphicsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	// Initialize the variables and update the dialog window
	m_iColor = 0;
	m_iShape = 0;
	m_iTool = 0;
	UpdateData(FALSE);
	m_strBitmap = "";

	// Create the second dialog window
	m_dlgPaint.Create(IDD_PAINT_DLG, this);
	// Show the second dialog window
	m_dlgPaint.ShowWindow(SW_SHOW);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGraphicsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGraphicsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGraphicsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGraphicsDlg::OnBexit() 
{
	// TODO: Add your control notification handler code here
	OnOK();
}

void CGraphicsDlg::OnBbitmap() 
{
	// TODO: Add your control notification handler code here
	
	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Build a filter for use in the File Open dialog
	static char BASED_CODE szFilter[] = "Bitmap Files (*.bmp)|*.bmp||";	
	// Create the File Open dialog
	CFileDialog dlgFile(TRUE, ".bmp", m_strBitmap, 
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);

	// Set the current directory
	//m_ldFile.m_ofn.lpstrInitialDir = "C:\\Temp\\";

	// Show the File Open dialog and capture the result
	if (dlgFile.DoModal() == IDOK)
	{
		// Get the file name selected
		m_strBitmap = dlgFile.GetPathName();
		// Load the selected bitmap file
		HBITMAP hBitmap = (HBITMAP) ::LoadImage(AfxGetInstanceHandle(),
			m_strBitmap, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_CREATEDIBSECTION);

		// Do we have a valid handle for the loaded image?
		if (hBitmap)
		{
			// Delete the current bitmap
			if (m_bBitmap.DeleteObject())
				// If there was a bitmap, detach it
				m_bBitmap.Detach();
			// Attach the currently loaded bitmap to the bitmap object
			m_bBitmap.Attach(hBitmap);
		}

		// Invalidate the second dialog window
		m_dlgPaint.Invalidate();
	}

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CGraphicsDlg::OnRcColor() 
{
	// TODO: Add your control notification handler code here

	// Synchronize the data
	UpdateData(TRUE);
	// Repaint the second dialog
	m_dlgPaint.Invalidate();	
}

void CGraphicsDlg::OnRsShape() 
{
	// TODO: Add your control notification handler code here

	// Synchronize the data
	UpdateData(TRUE);
	// Repaint the second dialog
	m_dlgPaint.Invalidate();	
}

void CGraphicsDlg::OnRtTool() 
{
	// TODO: Add your control notification handler code here

	// Synchronize the data
	UpdateData(TRUE);
	// Repaint the second dialog
	m_dlgPaint.Invalidate();	
}
