// Day10Doc.cpp : implementation of the CDay10Doc class
//

#include "stdafx.h"
#include "Day10.h"
#include "MainFrm.h"
#include "Line.h"
#include "Day10Doc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDay10Doc

IMPLEMENT_DYNCREATE(CDay10Doc, CDocument)

BEGIN_MESSAGE_MAP(CDay10Doc, CDocument)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_COLOR, OnUpdateIndicatorColor)
	//{{AFX_MSG_MAP(CDay10Doc)
	ON_UPDATE_COMMAND_UI(ID_WIDTH_VTHIN, OnUpdateWidthVthin)
	ON_UPDATE_COMMAND_UI(ID_WIDTH_VTHICK, OnUpdateWidthVthick)
	ON_UPDATE_COMMAND_UI(ID_WIDTH_THIN, OnUpdateWidthThin)
	ON_UPDATE_COMMAND_UI(ID_WIDTH_THICK, OnUpdateWidthThick)
	ON_UPDATE_COMMAND_UI(ID_WIDTH_MEDIUM, OnUpdateWidthMedium)
	ON_UPDATE_COMMAND_UI(ID_COLOR_YELLOW, OnUpdateColorYellow)
	ON_UPDATE_COMMAND_UI(ID_COLOR_WHITE, OnUpdateColorWhite)
	ON_UPDATE_COMMAND_UI(ID_COLOR_RED, OnUpdateColorRed)
	ON_UPDATE_COMMAND_UI(ID_COLOR_MAGENTA, OnUpdateColorMagenta)
	ON_UPDATE_COMMAND_UI(ID_COLOR_GREEN, OnUpdateColorGreen)
	ON_UPDATE_COMMAND_UI(ID_COLOR_CYAN, OnUpdateColorCyan)
	ON_UPDATE_COMMAND_UI(ID_COLOR_BLUE, OnUpdateColorBlue)
	ON_UPDATE_COMMAND_UI(ID_COLOR_BLACK, OnUpdateColorBlack)
	ON_COMMAND(ID_COLOR_BLACK, OnColorBlack)
	ON_COMMAND(ID_COLOR_BLUE, OnColorBlue)
	ON_COMMAND(ID_COLOR_CYAN, OnColorCyan)
	ON_COMMAND(ID_COLOR_GREEN, OnColorGreen)
	ON_COMMAND(ID_COLOR_MAGENTA, OnColorMagenta)
	ON_COMMAND(ID_COLOR_RED, OnColorRed)
	ON_COMMAND(ID_COLOR_WHITE, OnColorWhite)
	ON_COMMAND(ID_COLOR_YELLOW, OnColorYellow)
	ON_COMMAND(ID_WIDTH_MEDIUM, OnWidthMedium)
	ON_COMMAND(ID_WIDTH_THICK, OnWidthThick)
	ON_COMMAND(ID_WIDTH_THIN, OnWidthThin)
	ON_COMMAND(ID_WIDTH_VTHICK, OnWidthVthick)
	ON_COMMAND(ID_WIDTH_VTHIN, OnWidthVthin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

const COLORREF CDay10Doc::m_crColors[8] = {
	RGB(   0,   0,   0),	// Black
	RGB(   0,   0, 255),	// Blue
	RGB(   0, 255,   0),	// Green
	RGB(   0, 255, 255),	// Cyan
	RGB( 255,   0,   0),	// Red
	RGB( 255,   0, 255),	// Magenta
	RGB( 255, 255,   0),	// Yellow
	RGB( 255, 255, 255)		// White
};

/////////////////////////////////////////////////////////////////////////////
// CDay10Doc construction/destruction

CDay10Doc::CDay10Doc()
{
	// TODO: add one-time construction code here

}

CDay10Doc::~CDay10Doc()
{
}

BOOL CDay10Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	// Initialize the color to black
	m_nColor = ID_COLOR_BLACK - ID_COLOR_BLACK;
	m_nWidth = ID_WIDTH_MEDIUM - ID_WIDTH_VTHIN;
	UpdateColorbar(m_nWidth);
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CDay10Doc serialization

void CDay10Doc::Serialize(CArchive& ar)
{
	// Pass the serialization on to the object array
	m_oaLines.Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CDay10Doc diagnostics

#ifdef _DEBUG
void CDay10Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDay10Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDay10Doc commands

int CDay10Doc::GetLineCount()
{
	// Return the array count
	return m_oaLines.GetSize();
}

CPoint* CDay10Doc::GetTo(int nIndex)
{
	// Return a pointer to the To point in the
	// CLine object at the specified point in the
	// object array
	return ((CLine*)m_oaLines[nIndex])->GetTo();
}

CPoint* CDay10Doc::GetFrom(int nIndex)
{
	// Return a pointer to the From point in the
	// CLine object at the specified point in the
	// object array
	return ((CLine*)m_oaLines[nIndex])->GetFrom();
}

CLine * CDay10Doc::AddLine(CPoint ptFrom, CPoint ptTo)
{
	static UINT nWidths[5] = { 1, 8, 16, 24, 32};

	// Create a new CLine object
	CLine *pLine = new CLine(ptFrom, ptTo, nWidths[m_nWidth], m_crColors[m_nColor]);
	try
	{
		// Add the new line to the object array
		m_oaLines.Add(pLine);
		// Mark the document as dirty
		SetModifiedFlag();
	}
	// Did we run into a memory exception?
	catch (CMemoryException* perr)
	{
		// Display a message for the user, giving them the
		// bad news
		AfxMessageBox("Out of memory", MB_ICONSTOP | MB_OK);
		// Did we create a line object?
		if (pLine)
		{
			// Delete it
			delete pLine;
			pLine = NULL;
		}
		// Delete the exception object
		perr->Delete();
	}
	return pLine;
}

void CDay10Doc::DeleteContents() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Get the number of lines in the object array
	int iCount = m_oaLines.GetSize();
	int iPos;

	// Are there any objects in the array?
	if (iCount)
	{
		// Loop through the array, deleting each object
		for (iPos = 0; iPos < iCount; iPos++)
			delete m_oaLines[iPos];
		// Reset the array
		m_oaLines.RemoveAll();
	}

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////

	CDocument::DeleteContents();
}

CLine * CDay10Doc::GetLine(int nIndex)
{
	// Return a pointer to the line object
	// at the specified point in the object array
	return (CLine*)m_oaLines[nIndex];
}

UINT CDay10Doc::GetColor()
{
	// Return the current color
	return ID_COLOR_BLACK + m_nColor;
}

UINT CDay10Doc::GetWidth()
{
	// Return the current width
	return ID_WIDTH_VTHIN + m_nWidth;
}

void CDay10Doc::OnUpdateWidthVthin(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the Very Thin menu entry should be checked
//	pCmdUI->SetCheck(GetWidth() == ID_WIDTH_VTHIN ? 1 : 0);
	pCmdUI->SetRadio(GetWidth() == ID_WIDTH_VTHIN ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnUpdateWidthVthick(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the Very Thick menu entry should be checked
//	pCmdUI->SetCheck(GetWidth() == ID_WIDTH_VTHICK ? 1 : 0);
	pCmdUI->SetRadio(GetWidth() == ID_WIDTH_VTHICK ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnUpdateWidthThin(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the Thin menu entry should be checked
//	pCmdUI->SetCheck(GetWidth() == ID_WIDTH_THIN ? 1 : 0);
	pCmdUI->SetRadio(GetWidth() == ID_WIDTH_THIN ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnUpdateWidthThick(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the Thick menu entry should be checked
//	pCmdUI->SetCheck(GetWidth() == ID_WIDTH_THICK ? 1 : 0);
	pCmdUI->SetRadio(GetWidth() == ID_WIDTH_THICK ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnUpdateWidthMedium(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the Medium menu entry should be checked
//	pCmdUI->SetCheck(GetWidth() == ID_WIDTH_MEDIUM ? 1 : 0);
	pCmdUI->SetRadio(GetWidth() == ID_WIDTH_MEDIUM ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnUpdateColorYellow(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the Yellow menu entry should be checked
//	pCmdUI->SetCheck(GetColor() == ID_COLOR_YELLOW ? 1 : 0);
	pCmdUI->SetRadio(GetColor() == ID_COLOR_YELLOW ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnUpdateColorWhite(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the White menu entry should be checked
//	pCmdUI->SetCheck(GetColor() == ID_COLOR_WHITE ? 1 : 0);
	pCmdUI->SetRadio(GetColor() == ID_COLOR_WHITE ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnUpdateColorRed(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the Red menu entry should be checked
//	pCmdUI->SetCheck(GetColor() == ID_COLOR_RED ? 1 : 0);
	pCmdUI->SetRadio(GetColor() == ID_COLOR_RED ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnUpdateColorMagenta(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the Magenta menu entry should be checked
//	pCmdUI->SetCheck(GetColor() == ID_COLOR_MAGENTA ? 1 : 0);
	pCmdUI->SetRadio(GetColor() == ID_COLOR_MAGENTA ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnUpdateColorGreen(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the Green menu entry should be checked
//	pCmdUI->SetCheck(GetColor() == ID_COLOR_GREEN ? 1 : 0);
	pCmdUI->SetRadio(GetColor() == ID_COLOR_GREEN ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnUpdateColorCyan(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the Cyan menu entry should be checked
//	pCmdUI->SetCheck(GetColor() == ID_COLOR_CYAN ? 1 : 0);
	pCmdUI->SetRadio(GetColor() == ID_COLOR_CYAN ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnUpdateColorBlue(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the Blue menu entry should be checked
//	pCmdUI->SetCheck(GetColor() == ID_COLOR_BLUE ? 1 : 0);
	pCmdUI->SetRadio(GetColor() == ID_COLOR_BLUE ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnUpdateColorBlack(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Determine if the Black menu entry should be checked
//	pCmdUI->SetCheck(GetColor() == ID_COLOR_BLACK ? 1 : 0);
	pCmdUI->SetRadio(GetColor() == ID_COLOR_BLACK ? 1 : 0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnColorBlack() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current color to black
	m_nColor = 0;	

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnColorBlue() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current color to blue
	m_nColor = 1;

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnColorCyan() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current color to cyan
	m_nColor = 3;

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnColorGreen() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current color to green
	m_nColor = 2;

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnColorMagenta() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current color to magenta
	m_nColor = 5;

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnColorRed() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current color to red
	m_nColor = 4;

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnColorWhite() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current color to white
	m_nColor = 7;

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnColorYellow() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current color to yellow
	m_nColor = 6;

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnWidthMedium() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current width to medium
	m_nWidth = 2;
	// Update the colorbar
	UpdateColorbar(2);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnWidthThick() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current width to thick
	m_nWidth = 3;
	// Update the colorbar
	UpdateColorbar(3);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnWidthThin() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current width to thin
	m_nWidth = 1;
	// Update the colorbar
	UpdateColorbar(1);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnWidthVthick() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current width to very thick
	m_nWidth = 4;
	// Update the colorbar
	UpdateColorbar(4);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::OnWidthVthin() 
{
	// TODO: Add your command handler code here

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Set the current width to very thin
	m_nWidth = 0;
	// Update the colorbar
	UpdateColorbar(0);

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

void CDay10Doc::SetWidth(int nIndex)
{
	// Set the current width
	m_nWidth = nIndex;
}


void CDay10Doc::UpdateColorbar(int nIndex)
{
	POSITION pos = GetFirstViewPosition();
	if (pos != NULL)
	{
		CView* pView = GetNextView(pos);
		if (pView)
		{
			CMainFrame* pFrame = (CMainFrame*)pView->GetTopLevelFrame();
			if (pFrame)
				pFrame->UpdateWidthCB(nIndex);
		}
	}
}

void CDay10Doc::OnUpdateIndicatorColor(CCmdUI *pCmdUI)
{
	CString strColor;

	switch (m_nColor)
	{
	case 0:
		strColor = "BLACK";
		break;
	case 1:
		strColor = "BLUE";
		break;
	case 2:
		strColor = "GREEN";
		break;
	case 3:
		strColor = "CYAN";
		break;
	case 4:
		strColor = "RED";
		break;
	case 5:
		strColor = "MAGENTA";
		break;
	case 6:
		strColor = "YELLOW";
		break;
	case 7:
		strColor = "WHITE";
		break;
	}
	pCmdUI->Enable(TRUE);
	pCmdUI->SetText(strColor);
}
