// Line.cpp: implementation of the CLine class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Toolbar.h"
#include "Line.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_SERIAL (CLine, CObject, 1)
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLine::CLine()
{

}

CLine::~CLine()
{

}

CLine::CLine(CPoint ptFrom, CPoint ptTo)
{
	//Initialize the from an to points
	m_ptFrom = ptFrom;
	m_ptTo = ptTo;
	m_nWidth = 16;
	m_crColor = RGB(0, 0, 0);
}

CPoint * CLine::GetFrom()
{
	// Return the From point
	return &m_ptFrom;
}

CPoint * CLine::GetTo()
{	
	// Return the To point
	return &m_ptTo;
}

void CLine::Serialize(CArchive &ar)
{
	CObject::Serialize(ar);

	if (ar.IsStoring())
		ar << m_ptFrom << m_ptTo << m_nWidth << (DWORD) m_crColor;
	else
		ar >> m_ptFrom >> m_ptTo >> m_nWidth >> (DWORD) m_crColor;
}

void CLine::Draw(CDC * pDC)
{
	// Create a pen
	CPen lpen (PS_SOLID, m_nWidth, m_crColor);

	// Set the new pen as the drawing object
	CPen* pOldPen = pDC->SelectObject(&lpen);
	// Draw the line
	pDC->MoveTo(m_ptFrom);
	pDC->LineTo(m_ptTo);
	// Reset the previous pen
	pDC->SelectObject(pOldPen);
}

CLine::CLine(CPoint ptFrom, CPoint ptTo, UINT nWidth, COLORREF crColor)
{
	//Initialize the from and to points
	m_ptFrom = ptFrom;
	m_ptTo = ptTo;
	m_nWidth = nWidth;
	m_crColor = crColor;
}
