// ToolbarView.cpp : implementation of the CToolbarView class
//

#include "stdafx.h"
#include "Toolbar.h"

#include "Line.h"
#include "ToolbarDoc.h"
#include "ToolbarView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CToolbarView

IMPLEMENT_DYNCREATE(CToolbarView, CView)

BEGIN_MESSAGE_MAP(CToolbarView, CView)
	//{{AFX_MSG_MAP(CToolbarView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToolbarView construction/destruction

CToolbarView::CToolbarView()
{
	// TODO: add construction code here

}

CToolbarView::~CToolbarView()
{
}

BOOL CToolbarView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CToolbarView drawing

void CToolbarView::OnDraw(CDC* pDC)
{
	CToolbarDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Get the number of lines in the document
	int liCount = pDoc->GetLineCount();

	// Are there any lines in the document?
	if (liCount)
	{
		int liPos;
		CLine *lptLine;

		// Loop through the lines in the document
		for (liPos = 0; liPos < liCount; liPos++)
		{
			// Get the from and to point for each line
			lptLine = pDoc->GetLine(liPos);
			// Draw the line
			lptLine->Draw(pDC);
		}
	}

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////
}

/////////////////////////////////////////////////////////////////////////////
// CToolbarView printing

BOOL CToolbarView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CToolbarView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CToolbarView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CToolbarView diagnostics

#ifdef _DEBUG
void CToolbarView::AssertValid() const
{
	CView::AssertValid();
}

void CToolbarView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CToolbarDoc* CToolbarView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CToolbarDoc)));
	return (CToolbarDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CToolbarView message handlers

void CToolbarView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Capture the mouse, so no other application can
	// grab it if the mouse leaves the window area
	SetCapture();
	// Save the point
	m_ptPrevPos = point;

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////

	CView::OnLButtonDown(nFlags, point);
}

void CToolbarView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Have we captured the mouse?
	if (GetCapture() == this)
		// If so, release it so other applications can
		// have it
		ReleaseCapture();

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////

	CView::OnLButtonUp(nFlags, point);
}

void CToolbarView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////
	
	// Check to see if the left mouse button is down
	if ((nFlags & MK_LBUTTON) == MK_LBUTTON)
	{
		// Have we captured the mouse?
		if (GetCapture() == this)
		{
			// Get the Device Context
			CClientDC dc(this);

			// Add the line to the document
			CLine *pLine = GetDocument()->AddLine(m_ptPrevPos, point);

			// Draw the current stretch of line
			pLine->Draw(&dc);

			// Save the current point as the previous point
			m_ptPrevPos = point;
		}
	}

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////

	CView::OnMouseMove(nFlags, point);
}

void CToolbarView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CMenu *m_lMenu;
	CPoint m_pPoint;

	m_pPoint = point;
	ClientToScreen(&m_pPoint);
	m_lMenu = GetMenu();
	if (m_lMenu)
	{
	//m_lMenu = m_lMenu->GetSubMenu(0);
	m_lMenu->TrackPopupMenu(TPM_CENTERALIGN + TPM_LEFTBUTTON, 
		m_pPoint.x, m_pPoint.y, this, NULL);
	}
	CView::OnRButtonDown(nFlags, point);
}
