// Person.cpp: implementation of the CPerson class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Serialize.h"
#include "Person.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_SERIAL (CPerson, CObject, 2)
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPerson::CPerson()
{
	m_pDoc = NULL;
	m_iMartialStatus = 0;
	m_iAge = 0;
	m_bEmployed = FALSE;
	m_sName = "";
	m_iSex = 0;
}

CPerson::CPerson(CDocument* pDoc)
{
	m_pDoc = pDoc;
	m_iMartialStatus = 0;
	m_iAge = 0;
	m_bEmployed = FALSE;
	m_sName = "";
	m_iSex = 0;
}

CPerson::~CPerson()
{

}


void CPerson::Serialize(CArchive &ar)
{
	CObject::Serialize(ar);

	if (ar.IsStoring())
		ar << m_sName << m_iAge << m_iMartialStatus << m_bEmployed << m_iSex;
	else
		ar >> m_sName >> m_iAge >> m_iMartialStatus >> m_bEmployed >> m_iSex;
}

void CPerson::SetEmployed(BOOL bEmployed)
{
	m_bEmployed = bEmployed;
	if (m_pDoc)
		m_pDoc->SetModifiedFlag();
}

void CPerson::SetMartialStat(int iStat) 
{
	m_iMartialStatus = iStat;
	if (m_pDoc)
		m_pDoc->SetModifiedFlag();
}

void CPerson::SetSex(int iSex) 
{
	m_iSex = iSex;
	if (m_pDoc)
		m_pDoc->SetModifiedFlag();
}

void CPerson::SetAge(int iAge) 
{
	m_iAge = iAge;
	if (m_pDoc)
		m_pDoc->SetModifiedFlag();
}

void CPerson::SetName(CString sName) 
{
	m_sName = sName;
	if (m_pDoc)
		m_pDoc->SetModifiedFlag();
}
