// SerializeDoc.cpp : implementation of the CSerializeDoc class
//

#include "stdafx.h"
#include "Serialize.h"

#include "Person.h"
#include "SerializeDoc.h"
#include "SerializeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSerializeDoc

IMPLEMENT_DYNCREATE(CSerializeDoc, CDocument)

BEGIN_MESSAGE_MAP(CSerializeDoc, CDocument)
	//{{AFX_MSG_MAP(CSerializeDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSerializeDoc construction/destruction

CSerializeDoc::CSerializeDoc()
{
	// TODO: add one-time construction code here

}

CSerializeDoc::~CSerializeDoc()
{
}

BOOL CSerializeDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	if (!AddNewRecord())
		return FALSE;

	POSITION pos = GetFirstViewPosition();
	CSerializeView* pView = (CSerializeView*)GetNextView(pos);
	if (pView)
		pView->NewDataSet();

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CSerializeDoc serialization

void CSerializeDoc::Serialize(CArchive& ar)
{
	// Pass the serialization on to the object array
	m_oaPeople.Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CSerializeDoc diagnostics

#ifdef _DEBUG
void CSerializeDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSerializeDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSerializeDoc commands

CPerson* CSerializeDoc::GetCurRecord()
{
	if (m_iCurPosition >= 0)
		return (CPerson*)m_oaPeople[m_iCurPosition];
	else
		return NULL;
}

int CSerializeDoc::GetTotalRecords()
{
	// Return the array count
	return m_oaPeople.GetSize();
}

CPerson* CSerializeDoc::GetFirstRecord()
{
	if (m_oaPeople.GetSize() > 0)
	{
		m_iCurPosition = 0;
		return (CPerson*)m_oaPeople[0];
	}
	else
		return NULL;
}

CPerson * CSerializeDoc::GetNextRecord()
{
	if (++m_iCurPosition < m_oaPeople.GetSize())
		return (CPerson*)m_oaPeople[m_iCurPosition];
	else
		return AddNewRecord();
}

CPerson * CSerializeDoc::GetPrevRecord()
{
	if (m_oaPeople.GetSize() > 0)
	{
		if (--m_iCurPosition < 0)
			m_iCurPosition = 0;
		return (CPerson*)m_oaPeople[m_iCurPosition];
	}
	else
		return NULL;
}

CPerson * CSerializeDoc::GetLastRecord()
{
	if (m_oaPeople.GetSize() > 0)
	{
		m_iCurPosition = (m_oaPeople.GetSize() - 1);
		return (CPerson*)m_oaPeople[m_iCurPosition];
	}
	else
		return NULL;

}

CPerson * CSerializeDoc::AddNewRecord()
{
	// Create a new CPerson object
	CPerson *pPerson = new CPerson(this);
	try
	{
		// Add the new person to the object array
		m_oaPeople.Add(pPerson);
		// Mark the document as dirty
		SetModifiedFlag();
		// Set the new position mark
		m_iCurPosition = (m_oaPeople.GetSize() - 1);
	}
	// Did we run into a memory exception?
	catch (CMemoryException* perr)
	{
		// Display a message for the user, giving them the
		// bad news
		AfxMessageBox("Out of memory", MB_ICONSTOP | MB_OK);
		// Did we create a line object?
		if (pPerson)
		{
			// Delete it
			delete pPerson;
			pPerson = NULL;
		}
		// Delete the exception object
		perr->Delete();
	}
	return pPerson;
}

void CSerializeDoc::DeleteContents() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Get the number of lines in the object array
	int liCount = m_oaPeople.GetSize();
	int liPos;

	// Are there any objects in the array?
	if (liCount)
	{
		// Loop through the array, deleting each object
		for (liPos = 0; liPos < liCount; liPos++)
			delete m_oaPeople[liPos];
		// Reset the array
		m_oaPeople.RemoveAll();
	}

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////

	CDocument::DeleteContents();
}

BOOL CSerializeDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	// TODO: Add your specialized creation code here
	POSITION pos = GetFirstViewPosition();
	CSerializeView* pView = (CSerializeView*)GetNextView(pos);
	if (pView)
		pView->NewDataSet();
	
	return TRUE;
}
