// SerializeView.cpp : implementation of the CSerializeView class
//

#include "stdafx.h"
#include "Serialize.h"

#include "Person.h"
#include "SerializeDoc.h"
#include "SerializeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CSerializeView

IMPLEMENT_DYNCREATE(CSerializeView, CFormView)

BEGIN_MESSAGE_MAP(CSerializeView, CFormView)
	//{{AFX_MSG_MAP(CSerializeView)
	ON_BN_CLICKED(IDC_BFIRST, OnBfirst)
	ON_BN_CLICKED(IDC_BLAST, OnBlast)
	ON_BN_CLICKED(IDC_BNEXT, OnBnext)
	ON_BN_CLICKED(IDC_BPREV, OnBprev)
	ON_BN_CLICKED(IDC_CBEMPLOYED, OnCbemployed)
	ON_EN_CHANGE(IDC_EAGE, OnChangeEage)
	ON_EN_CHANGE(IDC_ENAME, OnChangeEname)
	ON_BN_CLICKED(IDC_RDIVORCED, OnStat)
	ON_BN_CLICKED(IDC_RMARRIED, OnStat)
	ON_BN_CLICKED(IDC_RSINGLE, OnStat)
	ON_BN_CLICKED(IDC_RWIDOW, OnStat)
	ON_BN_CLICKED(IDC_RMALE, OnSex)
	ON_BN_CLICKED(IDC_RFEMALE, OnSex)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSerializeView construction/destruction

CSerializeView::CSerializeView()
	: CFormView(CSerializeView::IDD)
{
	//{{AFX_DATA_INIT(CSerializeView)
	m_bEmployeed = FALSE;
	m_iAge = 0;
	m_sName = _T("");
	m_iMartialStatus = -1;
	m_sPosition = _T("");
	m_iSex = -1;
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CSerializeView::~CSerializeView()
{
}

void CSerializeView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSerializeView)
	DDX_Check(pDX, IDC_CBEMPLOYED, m_bEmployeed);
	DDX_Text(pDX, IDC_EAGE, m_iAge);
	DDX_Text(pDX, IDC_ENAME, m_sName);
	DDX_Radio(pDX, IDC_RSINGLE, m_iMartialStatus);
	DDX_Text(pDX, IDC_SPOSITION, m_sPosition);
	DDX_Radio(pDX, IDC_RMALE, m_iSex);
	//}}AFX_DATA_MAP
}

BOOL CSerializeView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CSerializeView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

}

/////////////////////////////////////////////////////////////////////////////
// CSerializeView printing

BOOL CSerializeView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSerializeView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSerializeView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CSerializeView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	// TODO: add code to print the controls
}

/////////////////////////////////////////////////////////////////////////////
// CSerializeView diagnostics

#ifdef _DEBUG
void CSerializeView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSerializeView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CSerializeDoc* CSerializeView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSerializeDoc)));
	return (CSerializeDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSerializeView message handlers

void CSerializeView::PopulateView()
{
	CSerializeDoc* pDoc = GetDocument();
	if (pDoc)
	{
		m_sPosition.Format("Record %d of %d", pDoc->GetCurRecordNbr(), pDoc->GetTotalRecords());
	}
	if (m_pCurPerson)
	{
		m_bEmployeed = m_pCurPerson->GetEmployed();
		m_iAge = m_pCurPerson->GetAge();
		m_sName = m_pCurPerson->GetName();
		m_iMartialStatus = m_pCurPerson->GetMartialStatus();
		m_iSex = m_pCurPerson->GetSex();
	}
	UpdateData(FALSE);
}

void CSerializeView::OnBfirst() 
{
	// TODO: Add your control notification handler code here
	CSerializeDoc * pDoc = GetDocument();
	if (pDoc)
	{
		m_pCurPerson = pDoc->GetFirstRecord();
		if (m_pCurPerson)
		{
			PopulateView();
		}
	}
}

void CSerializeView::OnBlast() 
{
	// TODO: Add your control notification handler code here
	CSerializeDoc * pDoc = GetDocument();
	if (pDoc)
	{
		m_pCurPerson = pDoc->GetLastRecord();
		if (m_pCurPerson)
		{
			PopulateView();
		}
	}
}

void CSerializeView::OnBnext() 
{
	// TODO: Add your control notification handler code here
	CSerializeDoc * pDoc = GetDocument();
	if (pDoc)
	{
		m_pCurPerson = pDoc->GetNextRecord();
		if (m_pCurPerson)
		{
			PopulateView();
		}
	}
}

void CSerializeView::OnBprev() 
{
	// TODO: Add your control notification handler code here
	CSerializeDoc * pDoc = GetDocument();
	if (pDoc)
	{
		m_pCurPerson = pDoc->GetPrevRecord();
		if (m_pCurPerson)
		{
			PopulateView();
		}
	}
}

void CSerializeView::OnCbemployed() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_pCurPerson)
		m_pCurPerson->SetEmployed(m_bEmployeed);
}

void CSerializeView::OnChangeEage() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitialUpdate()
	// function and call CRichEditCrtl().SetEventMask()
	// with the EN_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_pCurPerson)
		m_pCurPerson->SetAge(m_iAge);
}

void CSerializeView::OnChangeEname() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitialUpdate()
	// function and call CRichEditCrtl().SetEventMask()
	// with the EN_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_pCurPerson)
		m_pCurPerson->SetName(m_sName);
}

void CSerializeView::OnStat() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_pCurPerson)
		m_pCurPerson->SetMartialStat(m_iMartialStatus);
}

void CSerializeView::NewDataSet()
{
	OnBfirst();
}

void CSerializeView::OnSex() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_pCurPerson)
		m_pCurPerson->SetSex(m_iSex);
}
