// DbOdbcSet.cpp : implementation of the CDbOdbcSet class
//

#include "stdafx.h"
#include "DbOdbc.h"
#include "DbOdbcSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDbOdbcSet implementation

IMPLEMENT_DYNAMIC(CDbOdbcSet, CRecordset)

CDbOdbcSet::CDbOdbcSet(CDatabase* pdb)
	: CRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CDbOdbcSet)
	m_AddressID = 0;
	m_FirstName = _T("");
	m_LastName = _T("");
	m_SpouseName = _T("");
	m_Address = _T("");
	m_City = _T("");
	m_StateOrProvince = _T("");
	m_PostalCode = _T("");
	m_Country = _T("");
	m_EmailAddress = _T("");
	m_HomePhone = _T("");
	m_WorkPhone = _T("");
	m_WorkExtension = _T("");
	m_FaxNumber = _T("");
	//m_Birthdate = 0;
	m_SendCard = FALSE;
	m_Notes = _T("");
	m_nFields = 17;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dynaset;
}

CString CDbOdbcSet::GetDefaultConnect()
{
	return _T("ODBC;DSN=TYVCDB");
}

CString CDbOdbcSet::GetDefaultSQL()
{
	return _T("[Addresses]");
}

void CDbOdbcSet::DoFieldExchange(CFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CDbOdbcSet)
	pFX->SetFieldType(CFieldExchange::outputColumn);
	RFX_Long(pFX, _T("[AddressID]"), m_AddressID);
	RFX_Text(pFX, _T("[FirstName]"), m_FirstName);
	RFX_Text(pFX, _T("[LastName]"), m_LastName);
	RFX_Text(pFX, _T("[SpouseName]"), m_SpouseName);
	RFX_Text(pFX, _T("[Address]"), m_Address);
	RFX_Text(pFX, _T("[City]"), m_City);
	RFX_Text(pFX, _T("[StateOrProvince]"), m_StateOrProvince);
	RFX_Text(pFX, _T("[PostalCode]"), m_PostalCode);
	RFX_Text(pFX, _T("[Country]"), m_Country);
	RFX_Text(pFX, _T("[EmailAddress]"), m_EmailAddress);
	RFX_Text(pFX, _T("[HomePhone]"), m_HomePhone);
	RFX_Text(pFX, _T("[WorkPhone]"), m_WorkPhone);
	RFX_Text(pFX, _T("[WorkExtension]"), m_WorkExtension);
	RFX_Text(pFX, _T("[FaxNumber]"), m_FaxNumber);
	RFX_Date(pFX, _T("[Birthdate]"), m_Birthdate);
	RFX_Bool(pFX, _T("[SendCard]"), m_SendCard);
	RFX_Text(pFX, _T("[Notes]"), m_Notes);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CDbOdbcSet diagnostics

#ifdef _DEBUG
void CDbOdbcSet::AssertValid() const
{
	CRecordset::AssertValid();
}

void CDbOdbcSet::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG

long CDbOdbcSet::GetMaxID()
{
	// Move to the last record
	MoveLast();
	// return the ID of this record
	return m_AddressID;
}


