// DbOdbcView.cpp : implementation of the CDbOdbcView class
//

#include "stdafx.h"
#include "DbOdbc.h"

#include "DbOdbcSet.h"
#include "DbOdbcDoc.h"
#include "DbOdbcView.h"
#include "MoveToDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDbOdbcView

IMPLEMENT_DYNCREATE(CDbOdbcView, CRecordView)

BEGIN_MESSAGE_MAP(CDbOdbcView, CRecordView)
	//{{AFX_MSG_MAP(CDbOdbcView)
	ON_COMMAND(IDM_RECORD_NEW, OnRecordNew)
	ON_COMMAND(IDM_RECORD_DELETE, OnRecordDelete)
	ON_COMMAND(IDM_RECORD_MOVE, OnRecordMove)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CRecordView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CRecordView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRecordView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDbOdbcView construction/destruction

CDbOdbcView::CDbOdbcView()
	: CRecordView(CDbOdbcView::IDD)
{
	//{{AFX_DATA_INIT(CDbOdbcView)
	m_pSet = NULL;
	m_oledtDOB = COleDateTime::GetCurrentTime();
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CDbOdbcView::~CDbOdbcView()
{
}

void CDbOdbcView::DoDataExchange(CDataExchange* pDX)
{
	CRecordView::DoDataExchange(pDX);
	// Copy the DOB from the record set to the view variable
	if (pDX->m_bSaveAndValidate == FALSE)
		m_oledtDOB = m_pSet->m_Birthdate;
	//{{AFX_DATA_MAP(CDbOdbcView)
	DDX_FieldText(pDX, IDC_EID, m_pSet->m_AddressID, m_pSet);
	DDX_FieldText(pDX, IDC_EFNAME, m_pSet->m_FirstName, m_pSet);
	DDX_FieldText(pDX, IDC_ELNAME, m_pSet->m_LastName, m_pSet);
	DDX_FieldText(pDX, IDC_ESNAME, m_pSet->m_SpouseName, m_pSet);
	DDX_FieldText(pDX, IDC_ESTATE, m_pSet->m_StateOrProvince, m_pSet);
	DDX_FieldText(pDX, IDC_ECITY, m_pSet->m_City, m_pSet);
	DDX_FieldText(pDX, IDC_EADDR, m_pSet->m_Address, m_pSet);
	DDX_FieldCheck(pDX, IDC_CBCARD, m_pSet->m_SendCard, m_pSet);
	DDX_FieldText(pDX, IDC_ECOUNTRY, m_pSet->m_Country, m_pSet);
	DDX_FieldText(pDX, IDC_EEMAIL, m_pSet->m_EmailAddress, m_pSet);
	DDX_FieldText(pDX, IDC_EFAX, m_pSet->m_FaxNumber, m_pSet);
	DDX_FieldText(pDX, IDC_EHPHONE, m_pSet->m_HomePhone, m_pSet);
	DDX_FieldText(pDX, IDC_ENOTES, m_pSet->m_Notes, m_pSet);
	DDX_FieldText(pDX, IDC_EWEXT, m_pSet->m_WorkExtension, m_pSet);
	DDX_FieldText(pDX, IDC_EWPHONE, m_pSet->m_WorkPhone, m_pSet);
	DDX_FieldText(pDX, IDC_EZIP, m_pSet->m_PostalCode, m_pSet);
	DDX_Text(pDX, IDC_EDOB, m_oledtDOB);
	//}}AFX_DATA_MAP
	// Copy the DOB variable back from the view variable to the record set
	if (pDX->m_bSaveAndValidate == TRUE)
		m_pSet->m_Birthdate = m_oledtDOB;
}

BOOL CDbOdbcView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CRecordView::PreCreateWindow(cs);
}

void CDbOdbcView::OnInitialUpdate()
{
	m_pSet = &GetDocument()->m_DbOdbcSet;
	CRecordView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

}

/////////////////////////////////////////////////////////////////////////////
// CDbOdbcView printing

BOOL CDbOdbcView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDbOdbcView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDbOdbcView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDbOdbcView diagnostics

#ifdef _DEBUG
void CDbOdbcView::AssertValid() const
{
	CRecordView::AssertValid();
}

void CDbOdbcView::Dump(CDumpContext& dc) const
{
	CRecordView::Dump(dc);
}

CDbOdbcDoc* CDbOdbcView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDbOdbcDoc)));
	return (CDbOdbcDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDbOdbcView database support
CRecordset* CDbOdbcView::OnGetRecordset()
{
	return m_pSet;
}


/////////////////////////////////////////////////////////////////////////////
// CDbOdbcView message handlers

void CDbOdbcView::OnRecordNew() 
{
	// TODO: Add your command handler code here
	// Get a pointer to the record set
	CRecordset* pSet = OnGetRecordset();
	// Make sure that any changes to the current record
	// have been saved
	if (pSet->CanUpdate() && !pSet->IsDeleted())
	{
		pSet->Edit();
		if (!UpdateData())
			return;

		pSet->Update();
	}
	// Get the ID for the new record
	long m_lNewID = m_pSet->GetMaxID() + 1;
	// Add the new record
	m_pSet->AddNew();
	// Set the ID in the new record
	m_pSet->m_AddressID = m_lNewID;
	// Save the new record
	m_pSet->Update();
	// Refresh the record set
	m_pSet->Requery();
	// Move to the new record
	m_pSet->MoveLast();
	// Update the form
	UpdateData(FALSE);
}

void CDbOdbcView::OnRecordDelete() 
{
	// TODO: Add your command handler code here
	// Make sure the user wants to delete this record
	if (MessageBox("Are you sure you want to delete this record?",
					"Delete this record?", MB_YESNO | MB_ICONQUESTION) == IDYES)
	{
		// Delete the record
		m_pSet->Delete();
		// Move to the previous record
		m_pSet->MovePrev();
		// Update the form
		UpdateData(FALSE);
	}
}

void CDbOdbcView::OnRecordMove() 
{
	// TODO: Add your command handler code here
	// Create an instance of the Move To dialog
	CMoveToDlg dlgMoveTo;
	// Get the row number to move to
	if (dlgMoveTo.DoModal() == IDOK)
	{
		// Get a pointer to the record set
		CRecordset* pSet = OnGetRecordset();
		// Make sure that there are no outstanding changes to be saved
		if (pSet->CanUpdate() && !pSet->IsDeleted())
		{
			pSet->Edit();
			if (!UpdateData())
				return;

			pSet->Update();
		}
		// Set the new position
		pSet->SetAbsolutePosition(dlgMoveTo.m_lRowNbr);
		// Update the form
		UpdateData(FALSE);
	}
}
