// Day11Doc.cpp : implementation of the CDay11Doc class
//

#include "stdafx.h"
#include "Day11.h"

#include "Line.h"
#include "Day11Doc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDay11Doc

IMPLEMENT_DYNCREATE(CDay11Doc, CDocument)

BEGIN_MESSAGE_MAP(CDay11Doc, CDocument)
	ON_COMMAND_RANGE(ID_COLOR_BLACK, ID_COLOR_WHITE, OnColorCommand)
	ON_COMMAND_RANGE(ID_WIDTH_VTHIN, ID_WIDTH_VTHICK, OnWidthCommand)
	ON_UPDATE_COMMAND_UI_RANGE(ID_COLOR_BLACK, ID_COLOR_WHITE, OnUpdateColorUI)
	ON_UPDATE_COMMAND_UI_RANGE(ID_WIDTH_VTHIN, ID_WIDTH_VTHICK, OnUpdateWidthUI)
	//{{AFX_MSG_MAP(CDay11Doc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

const COLORREF CDay11Doc::m_crColors[8] = {
	RGB(   0,   0,   0),	// Black
	RGB(   0,   0, 255),	// Blue
	RGB(   0, 255,   0),	// Green
	RGB(   0, 255, 255),	// Cyan
	RGB( 255,   0,   0),	// Red
	RGB( 255,   0, 255),	// Magenta
	RGB( 255, 255,   0),	// Yellow
	RGB( 255, 255, 255)		// White
};
/////////////////////////////////////////////////////////////////////////////
// CDay11Doc construction/destruction

CDay11Doc::CDay11Doc()
{
	// TODO: add one-time construction code here

}

CDay11Doc::~CDay11Doc()
{
}

BOOL CDay11Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Initialize the color to black
	m_nColor = ID_COLOR_BLACK - ID_COLOR_BLACK;
	m_nWidth = ID_WIDTH_VTHIN - ID_WIDTH_VTHIN;

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CDay11Doc serialization

void CDay11Doc::Serialize(CArchive& ar)
{
	// Pass the serialization on to the object array
	m_oaLines.Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CDay11Doc diagnostics

#ifdef _DEBUG
void CDay11Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDay11Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDay11Doc commands

UINT CDay11Doc::GetWidth()
{
	// Return the current width
	return ID_WIDTH_VTHIN + m_nWidth;
}

UINT CDay11Doc::GetColor()
{
	// Return the current color
	return ID_COLOR_BLACK + m_nColor;
}

CLine * CDay11Doc::GetLine(int nIndex)
{
	// Return a pointer to the line object
	// at the specified point in the object array
	return (CLine*)m_oaLines[nIndex];
}

CLine * CDay11Doc::AddLine(CPoint ptFrom, CPoint ptTo)
{
	static UINT nWidths[5] = { 1, 8, 16, 24, 32};

	// Create a new CLine object
	CLine *pLine = new CLine(ptFrom, ptTo, nWidths[m_nWidth], m_crColors[m_nColor]);
	try
	{
		// Add the new line to the object array
		m_oaLines.Add(pLine);
		// Mark the document as dirty
		SetModifiedFlag();
	}
	// Did we run into a memory exception?
	catch (CMemoryException* perr)
	{
		// Display a message for the user, giving them the
		// bad news
		AfxMessageBox("Out of memory", MB_ICONSTOP | MB_OK);
		// Did we create a line object?
		if (pLine)
		{
			// Delete it
			delete pLine;
			pLine = NULL;
		}
		// Delete the exception object
		perr->Delete();
	}
	return pLine;
}

int CDay11Doc::GetLineCount()
{
	// Return the array count
	return m_oaLines.GetSize();
}

void CDay11Doc::DeleteContents() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Get the number of lines in the object array
	int liCount = m_oaLines.GetSize();
	int liPos;

	// Are there any objects in the array?
	if (liCount)
	{
		// Loop through the array, deleting each object
		for (liPos = 0; liPos < liCount; liPos++)
			delete m_oaLines[liPos];
		// Reset the array
		m_oaLines.RemoveAll();
	}

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////

	CDocument::DeleteContents();
}

void CDay11Doc::OnColorCommand(UINT nID) 
{
	// Set the current color
	m_nColor = nID - ID_COLOR_BLACK;
}

void CDay11Doc::OnUpdateColorUI(CCmdUI* pCmdUI) 
{
	// Determine if the menu entry should be checked
	pCmdUI->SetCheck(GetColor() == pCmdUI->m_nID ? 1 : 0);
}

void CDay11Doc::OnWidthCommand(UINT nID) 
{
	// Set the current width
	m_nWidth = nID - ID_WIDTH_VTHIN;
}

void CDay11Doc::OnUpdateWidthUI(CCmdUI* pCmdUI) 
{
	// Determine if the menu entry should be checked
	pCmdUI->SetCheck(GetWidth() == pCmdUI->m_nID ? 1 : 0);
}
