// TaskingDoc.cpp : implementation of the CTaskingDoc class
//

#include "stdafx.h"
#include "Tasking.h"

#include "Spinner.h"
#include "TaskingDoc.h"
#include "TaskingView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTaskingDoc

IMPLEMENT_DYNCREATE(CTaskingDoc, CDocument)

BEGIN_MESSAGE_MAP(CTaskingDoc, CDocument)
	//{{AFX_MSG_MAP(CTaskingDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTaskingDoc construction/destruction

CTaskingDoc::CTaskingDoc()
{
	// TODO: add one-time construction code here

}

CTaskingDoc::~CTaskingDoc()
{
}

BOOL CTaskingDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	///////////////////////
	// MY CODE STARTS HERE
	///////////////////////

	// Initialize the spinners
	InitSpinners();

	// Initialize the thread pointers
	m_pSpinThread[0] = NULL;
	m_pSpinThread[1] = NULL;

	///////////////////////
	// MY CODE ENDS HERE
	///////////////////////

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CTaskingDoc serialization

void CTaskingDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CTaskingDoc diagnostics

#ifdef _DEBUG
void CTaskingDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CTaskingDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTaskingDoc commands

void CTaskingDoc::CalcPoint(int nID, CSpinner *pSpin)
{
	RECT lWndRect;
	CPoint pPos;
	int iLength;
	CTaskingView *pWnd;

	// Get a pointer to the view window
	pWnd = (CTaskingView*)pSpin->GetViewWnd();
	// Get the display area rectangle
	pWnd->GetClientRect(&lWndRect);
	// Calculate the size of the spinners
	iLength = lWndRect.right / 6;
	// Which spinner are we placing?
	switch (nID)
	{
	case 0:	// Position the first spinner
		pPos.x = (lWndRect.right / 4) - iLength;
		pPos.y = (lWndRect.bottom / 4) - iLength;
		break;
	case 1:	// Position the second spinner
		pPos.x = ((lWndRect.right / 4) * 3) - iLength;
		pPos.y = (lWndRect.bottom / 4) - iLength;
		break;
	case 2:	// Position the third spinner
		pPos.x = (lWndRect.right / 4) - iLength;
		pPos.y = ((lWndRect.bottom / 4) * 3) - (long)(iLength * 1.25);
		break;
	case 3:	// Position the fourth spinner
		pPos.x = ((lWndRect.right / 4) * 3) - iLength;
		pPos.y = ((lWndRect.bottom / 4) * 3) - (long)(iLength * 1.25);
		break;
	}
	// Set the size of the spinner
	pSpin->SetLength(iLength);
	// Set the location of the spinner
	pSpin->SetPoint(pPos);
}

void CTaskingDoc::InitSpinners()
{
	int i;

	// Get the position of the view
	POSITION pos = GetFirstViewPosition();
	// Did we get a valid position?
	if (pos != NULL)
	{
		// Get a pointer to the view
		CView* pView = GetNextView(pos);

		// Loop through the spinners
		for (i = 0; i < 4; i++)
		{
			// Set the pointer to the view
			m_cSpin[i].SetViewWnd(pView);
			// Initialize the pointer to the continuation indicator
			m_cSpin[i].SetContinue(NULL);
			switch (i)
			{
			case 1:	// Set the pointer to the first thread continuation indicator
				m_cSpin[i].SetContinue(&((CTaskingView*)pView)->m_bThread1);
				break;
			case 3:	// Set the pointer to the second thread continuation indicator
				m_cSpin[i].SetContinue(&((CTaskingView*)pView)->m_bThread2);
				break;
			}
			// Calculate the location of the spinner
			CalcPoint(i, &m_cSpin[i]);
		}
	}
}

void CTaskingDoc::DoSpin(int nIndex)
{
	// Spin the Spinner
	m_cSpin[nIndex].Draw();
}

UINT CTaskingDoc::ThreadFunc(LPVOID pParam)
{
	// Convert the argument to a pointer to the
	// spinner for this thread
	CSpinner* lpSpin = (CSpinner*)pParam;
	// Get a pointer to the continuation flag
	BOOL* pbContinue = lpSpin->GetContinue();

	// Loop while the continue flag is true
	while (TRUE) //(*pbContinue)
		// Spin the spinner
		lpSpin->Draw();
	return 0;
}

void CTaskingDoc::SuspendSpinner(int nIndex, BOOL bSuspend)
{
	// if suspending the thread
	if (!bSuspend)
	{
		// Is the pointer for the thread valid?
		if (m_pSpinThread[nIndex])
		{
			// Suspend the thread
			m_pSpinThread[nIndex]->SuspendThread();
			// Get the handle for the thread
//			HANDLE hThread = m_pSpinThread[nIndex]->m_hThread;
			// Wait for the thread to die
//			::WaitForSingleObject (hThread, INFINITE);
		}
	}
	else	// We are running the thread
	{
		// Is the pointer for the thread valid?
		if (m_pSpinThread[nIndex])
		{
			// Resume the thread
			m_pSpinThread[nIndex]->ResumeThread();
		}
		else
		{
		int iSpnr;
		int iPriority;
		// Which spinner to use?
		switch (nIndex)
		{
		case 0:
			iSpnr = 1;
			iPriority = THREAD_PRIORITY_NORMAL;
			break;
		case 1:
			iSpnr = 3;
			iPriority = THREAD_PRIORITY_LOWEST;
			break;
		}
		// Start the thread, passing a pointer to the spinner
		m_pSpinThread[nIndex] = AfxBeginThread(ThreadFunc, 
			(LPVOID)&m_cSpin[iSpnr], iPriority);
		}
	}
}
