// SquiggleCtl.cpp : Implementation of the CSquiggleCtrl ActiveX Control class.

#include "stdafx.h"
#include "Squiggle.h"
#include "SquiggleCtl.h"
#include "SquigglePpg.h"
#include "ModArt.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CSquiggleCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CSquiggleCtrl, COleControl)
	//{{AFX_MSG_MAP(CSquiggleCtrl)
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CSquiggleCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CSquiggleCtrl)
	DISP_PROPERTY_NOTIFY(CSquiggleCtrl, "KeepCurrentDrawing", m_keepCurrentDrawing, OnKeepCurrentDrawingChanged, VT_BOOL)
	DISP_PROPERTY_EX(CSquiggleCtrl, "SquiggleLength", GetSquiggleLength, SetSquiggleLength, VT_I2)
	DISP_PROPERTY_EX(CSquiggleCtrl, "NumberSquiggles", GetNumberSquiggles, SetNumberSquiggles, VT_I2)
	DISP_FUNCTION(CSquiggleCtrl, "LoadDrawing", LoadDrawing, VT_BOOL, VTS_BSTR)
	DISP_FUNCTION(CSquiggleCtrl, "GenNewDrawing", GenNewDrawing, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CSquiggleCtrl, "SaveDrawing", SaveDrawing, VT_BOOL, VTS_BSTR)
	DISP_STOCKFUNC_DOCLICK()
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CSquiggleCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CSquiggleCtrl, COleControl)
	//{{AFX_EVENT_MAP(CSquiggleCtrl)
	EVENT_CUSTOM("FileLoaded", FireFileLoaded, VTS_NONE)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CSquiggleCtrl, 1)
	PROPPAGEID(CSquigglePropPage::guid)
END_PROPPAGEIDS(CSquiggleCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CSquiggleCtrl, "SQUIGGLE.SquiggleCtrl.1",
	0x2d6891d6, 0xe102, 0x11d1, 0xad, 0xd1, 0, 0xa0, 0x24, 0x29, 0xd9, 0x66)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CSquiggleCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DSquiggle =
		{ 0x2d6891d4, 0xe102, 0x11d1, { 0xad, 0xd1, 0, 0xa0, 0x24, 0x29, 0xd9, 0x66 } };
const IID BASED_CODE IID_DSquiggleEvents =
		{ 0x2d6891d5, 0xe102, 0x11d1, { 0xad, 0xd1, 0, 0xa0, 0x24, 0x29, 0xd9, 0x66 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwSquiggleOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CSquiggleCtrl, IDS_SQUIGGLE, _dwSquiggleOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CSquiggleCtrl::CSquiggleCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CSquiggleCtrl

BOOL CSquiggleCtrl::CSquiggleCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_SQUIGGLE,
			IDB_SQUIGGLE,
			afxRegApartmentThreading,
			_dwSquiggleOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CSquiggleCtrl::CSquiggleCtrl - Constructor

CSquiggleCtrl::CSquiggleCtrl()
{
	InitializeIIDs(&IID_DSquiggle, &IID_DSquiggleEvents);

	// TODO: Initialize your control's instance data here.
	// Initialize the variables
	m_bGenNewDrawing = TRUE;
	m_keepCurrentDrawing = FALSE;
}


/////////////////////////////////////////////////////////////////////////////
// CSquiggleCtrl::~CSquiggleCtrl - Destructor

CSquiggleCtrl::~CSquiggleCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CSquiggleCtrl::OnDraw - Drawing function

void CSquiggleCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
	//pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	//pdc->Ellipse(rcBounds);
	// Do we need to generate a new drawing?
	if (m_bGenNewDrawing)
	{
		// Set the drawing area for the new drawing
		m_maDrawing.SetRect(rcBounds);
		// Clear out the old drawing
		m_maDrawing.ClearDrawing();
		// Generate the new drawing
		m_maDrawing.NewDrawing();
		// Reset the control flag
		m_bGenNewDrawing = FALSE;
	}
	// Fill in the background
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	// Draw the squiggle drawing
	m_maDrawing.Draw(pdc);
}


/////////////////////////////////////////////////////////////////////////////
// CSquiggleCtrl::DoPropExchange - Persistence support

void CSquiggleCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CSquiggleCtrl::OnResetState - Reset control to default state

void CSquiggleCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CSquiggleCtrl::AboutBox - Display an "About" box to the user

void CSquiggleCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_SQUIGGLE);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CSquiggleCtrl message handlers

short CSquiggleCtrl::GetSquiggleLength() 
{
	// TODO: Add your property handler here

	// Return the result from the GetLength function
	return m_maDrawing.GetLength();
}

void CSquiggleCtrl::SetSquiggleLength(short nNewValue) 
{
	// TODO: Add your property handler here

	// Set the new length value
	m_maDrawing.SetLength(nNewValue);
	SetModifiedFlag();
}

short CSquiggleCtrl::GetNumberSquiggles() 
{
	// TODO: Add your property handler here

	// Return the result from the GetSegments function
	return m_maDrawing.GetSegments();
}

void CSquiggleCtrl::SetNumberSquiggles(short nNewValue) 
{
	// TODO: Add your property handler here

	// Set the new segments value
	m_maDrawing.SetSegments(nNewValue);
	SetModifiedFlag();
}

void CSquiggleCtrl::OnKeepCurrentDrawingChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}


void CSquiggleCtrl::OnClick(USHORT iButton) 
{
	// TODO: Add your specialized code here and/or call the base class
	// Can we generate a new drawing?
	if (!m_keepCurrentDrawing)
	{
		// Set the flag so a new drawing will be generated
		m_bGenNewDrawing = TRUE;
		// Invalidate the control to trigger the OnDraw function
		Invalidate();
	}
	COleControl::OnClick(iButton);
}

BOOL CSquiggleCtrl::LoadDrawing(LPCTSTR sFileName) 
{
	// TODO: Add your dispatch handler code here
	try
	{
		// Create a CFile object
		CFile lFile(sFileName, CFile::modeRead);
		// Create a CArchive object to load the file
		CArchive lArchive(&lFile, CArchive::load);
		// Load the file
		m_maDrawing.Serialize(lArchive);
		// Make sure that the loaded drawing won't be overwritten
		m_bGenNewDrawing = FALSE;
		// Draw the loaded drawing
		Invalidate();
		// Fire the FileLoaded event
		FireFileLoaded();
	}
	catch (CFileException err)
	{
		return FALSE;
	}
	return TRUE;
}

void CSquiggleCtrl::GenNewDrawing() 
{
	// TODO: Add your dispatch handler code here
	// Set the flag so a new drawing will be generated
	m_bGenNewDrawing = TRUE;
	// Invalidate the control to trigger the OnDraw function
	Invalidate();

}

BOOL CSquiggleCtrl::SaveDrawing(LPCTSTR sFileName) 
{
	// TODO: Add your dispatch handler code here

	try
	{
		// Create a CFile object
		CFile lFile(sFileName, CFile::modeWrite);
		// Create a CArchive object to store the file
		CArchive lArchive(&lFile, CArchive::store);
		// Store the file
		m_maDrawing.Serialize(lArchive);
	}
	catch (CFileException err)
	{
		return FALSE;
	}
	return TRUE;
}
